{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}
{}
{    MarinovSoft          }
{      BMP   }
{      3.90                  }
{   24.06.03  0.01.02       }
{  / 27.06.03     }
{ 0.01.03  BUG  ,    }
{                                  }
{   14.07.03  0.01.04       }
{  BUG (  1 ),        }
{  BUG -     -  }
{                             }
{   15.02.04  0.01.05       }
{  BUG -    -  }
{  (         }
{    ). Round     }
{   ,   Borland Pascal -     }
{                          }
{   03.06.06  0.01.06       }
{        }
{  .                                 }
{    32- , -}
{    32-     }
{  24-    24-      }
{   07.06.06  0.01.07       }
{  -     - }
{ (  640x480    640x480)    }
{  -     -}
{  Readed         }
{  (DX-Readed) .     }
{  .                                   }
{                                                     }
{                                                     }
{}

Unit Bmpunit;
Interface
Type
  PScrArray = ^TScrArray;
  TScrArray = Array[0..2000, 0..2000] Of LongInt;
Const
  bi_RGB  = 0;
  bi_RLE8 = 1;
  bi_RLE4 = 2;

Type
  TRGBQuad = Record
    rgbBlue: Byte;
    rgbGreen: Byte;
    rgbRed: Byte;
    rgbReserved: Byte;
  End;

Type
  PBitmapInfoHeader = ^TBitmapInfoHeader;
  TBitmapInfoHeader = Record
    biSize: LongInt;
    biWidth: LongInt;
    biHeight: LongInt;
    biPlanes: Word;
    biBitCount: Word;
    biCompression: LongInt;
    biSizeImage: LongInt;
    biXPelsPerMeter: LongInt;
    biYPelsPerMeter: LongInt;
    biClrUsed: LongInt;
    biClrImportant: LongInt;
  End;

Type
  PBitmapInfo = ^TBitmapInfo;
  TBitmapInfo = Record
    bmiHeader: TBitmapInfoHeader;
    {              Bmicolors: Array[0..0] Of TRGBquad;}
  End;

Type
  PBitmapFileHeader = ^TBitmapFileHeader;
  TBitmapFileHeader = Record
    bfType: Word;
    bfSize: LongInt;
    bfReserved1: Word;
    bfReserved2: Word;
    bfOffBits: LongInt;
  End;
Type
  Pbitmap = ^TBitmap;
  TBitmap = Object
    Xx,Yy:Word;
    Nposx,Nposy:Word;
    ScrArray:PScrArray;
    F:File;
    Error:Word;
    Constructor Init(FileName:String);
    Procedure LoadBitmap(X,Y:Word);Virtual;
    Procedure Draw;Virtual;
    Procedure RotateBitmap;Virtual;
    Procedure VerboseBitmap;Virtual;
    Destructor Done;
  End;
Implementation
Uses Graph;

Procedure HiLoByte(Var1:Byte;Var V1,V2:Byte);
Var B:Word;
Begin
  B:=Var1;
  B:=B ShL 4;
  V1:=Hi(B);
  B:=B ShL 8;
  B:=B ShR 12;
  V2:=Lo(B);
End;

Function R32(Ddx:Word):Word;
Begin
  If Ddx Mod 4 > 0 Then Inc(Ddx,4);
  Ddx:=Ddx Div 4;
  Ddx:=Ddx*4;
  R32:=Ddx;
End;

Constructor TBitmap.Init(FileName: String);
Var
  Fh:TBitmapFileHeader;
  Bi:TBitmapInfo;
  K:Byte;
  K4:LongInt;
  I,J:LongInt;
  Massiv:Array[0..5000] Of Byte;
  DX:Word;
  Dy:Word;
  Readed:Word;
Procedure Load24Bitmap;
Begin
  If Error<>0 Then Exit;
  Seek(F,Fh.bfOffBits);
  DX:=DX*3;
  DX:=R32(DX);
  For J:=Dy Downto 1 Do
  Begin
//    Readed:=1+3*Bi.bmiHeader.biWidth;
//    BlockRead(F,Massiv,Bi.bmiHeader.biWidth*3);
    BlockRead(F,Massiv,DX);
    I:=0;
    While I<Bi.bmiHeader.biWidth*3 Do
    Begin
      //PutPixel(I Div 3+Nposx,J+Nposy,Massiv[I]+(Massiv[I+1]ShL 8)+(Massiv[I+2] ShL 16));
      ScrArray^[I Div 3,J]:=Massiv[I]+(Massiv[I+1]ShL 8)+(Massiv[I+2] ShL 16);
      Inc(I,3);
    End;
//    For I:=Readed To DX Do BlockRead(F,K,1);
  End;
End;
Procedure Load256Bitmap;
Var
  ColorArray:Array[0..255] Of LongInt;
  RGB:TRGBQuad;
Begin
  If Error<>0 Then Exit;
  DX:=R32(DX);
  For I:=0 To 255 Do
  Begin
    BlockRead(F,RGB,SizeOf(RGB));
    ColorArray[I]:=RGB.rgbRed ShL 16+RGB.rgbBlue+RGB.rgbGreen ShL 8;
  End;
  Seek(F,Fh.bfOffBits);
  For J:=Dy Downto 1 Do
  Begin
    BlockRead(F,Massiv,DX);
{    BlockRead(F,Massiv,Bi.bmiHeader.biWidth);
    For I:=Bi.bmiHeader.biWidth+1 To DX Do
      BlockRead(F,K,1);}
    For I:=0 To Bi.bmiHeader.biWidth-1 Do
      //                   PutPixel(I+Nposx,J+Nposy,ColorArray[Massiv[I]]);
    ScrArray^[I,J]:=ColorArray[Massiv[I]];
  End;
End;
Function NewRound(Ddx:Word):Word;
Var
  Per01,Per02:Real;
Begin
  Per01:=Int(Ddx/2);
  Per02:=DX/2;
  If Per02>Per01 Then Per01:=Per01+1;
  NewRound:=Trunc(Per01);
End;
Procedure Load16Bitmap;
Var
  ColorArray:Array[0..15] Of LongInt;
  RGB:TRGBQuad;
  Hb,Lb:Byte;
Begin
  {     colorarray[0]:=0;}
  If Error<>0 Then Exit;
  For I:=0 To 15 Do
  Begin
    BlockRead(F,RGB,SizeOf(RGB));
    ColorArray[I]:=RGB.rgbRed ShL 16+RGB.rgbBlue+RGB.rgbGreen ShL 8;
  End;
  Seek(F,Fh.bfOffBits);
  DX:=Bi.bmiHeader.biWidth;
  DX:=NewRound(DX);
  DX:=R32(DX);
  For J:=Dy Downto 1 Do
  Begin
    BlockRead(F,Massiv,{bi.bmiheader.biwidth div 2}DX );
    I:=0;
    While I<=Bi.bmiHeader.biWidth Do
      Begin
        K:=Massiv[I Div 2];
        HiLoByte(K,Hb,Lb);
        //    PutPixel(I+Nposx,J+Nposy,ColorArray[Hb]);
        //    PutPixel(I+1+Nposx,J+Nposy,ColorArray[Lb]);
        ScrArray^[I,J]:=ColorArray[Hb];
        ScrArray^[I+1,J]:=ColorArray[Lb];
        Inc(I,2);
      End;
  End;
End;
Procedure LoadMonoBitmap;
Var
  ColorArray:Array[0..1] Of LongInt;
  RGB:TRGBQuad;
Begin
  If Error<>0 Then Exit;
  BlockRead(F,RGB,SizeOf(RGB));
  ColorArray[0]:=RGB.rgbRed ShL 16+RGB.rgbBlue+RGB.rgbGreen ShL 8;
  BlockRead(F,RGB,SizeOf(RGB));
  ColorArray[1]:=RGB.rgbRed ShL 16+RGB.rgbBlue+RGB.rgbGreen ShL 8;
  Seek(F,Fh.bfOffBits);
  DX:=Bi.bmiHeader.biWidth+7;
  DX:=DX Div 8;
  DX:=R32(DX);
  For J:=Bi.bmiHeader.biHeight Downto 1 Do
  Begin
    I:=0;
    BlockRead(F,Massiv,DX);
    While I<{bi.bmiheader.biwidth}DX*8 Do
    Begin
      K:=Massiv[I Div 8];
      If (K And $80)=0 Then ScrArray^[I,J]:=ColorArray[0] Else ScrArray^[I,J]:=ColorArray[1];
      If (K And $40)=0 Then ScrArray^[I+1,J]:=ColorArray[0] Else ScrArray^[I+1,J]:=ColorArray[1];
      If (K And $20)=0 Then ScrArray^[I+2,J]:=ColorArray[0] Else ScrArray^[I+2,J]:=ColorArray[1];
      If (K And $10)=0 Then ScrArray^[I+3,J]:=ColorArray[0] Else ScrArray^[I+3,J]:=ColorArray[1];
      If (K And $08)=0 Then ScrArray^[I+4,J]:=ColorArray[0] Else ScrArray^[I+4,J]:=ColorArray[1];
      If (K And $04)=0 Then ScrArray^[I+5,J]:=ColorArray[0] Else ScrArray^[I+5,J]:=ColorArray[1];
      If (K And $02)=0 Then ScrArray^[I+6,J]:=ColorArray[0] Else ScrArray^[I+6,J]:=ColorArray[1];
      If (K And $01)=0 Then ScrArray^[I+7,J]:=ColorArray[0] Else ScrArray^[I+7,J]:=ColorArray[1];
      Inc(I,8);
    End;
  End;
End;
Procedure Load32Bitmap;
Begin
  If Error<>0 Then Exit;
  Seek(F,Fh.bfOffBits);
  DX:=DX*4;
  DX:=R32(DX);
  For J:=Dy Downto 1 Do
  Begin
{    Readed:=1+4*Bi.bmiHeader.biWidth;
    BlockRead(F,Massiv,Bi.bmiHeader.biWidth*4);}
    BlockRead(F,Massiv,DX);
    I:=0;
    While I<Bi.bmiHeader.biWidth*4 Do
    Begin
      //PutPixel(I Div 3+Nposx,J+Nposy,Massiv[I]+(Massiv[I+1]ShL 8)+(Massiv[I+2] ShL 16));
      ScrArray^[I Div 4,J]:=Massiv[I]+(Massiv[I+1]ShL 8)+(Massiv[I+2] ShL 16);
      Inc(I,4);
    End;
{    For I:=Readed To DX Do BlockRead(F,K,1);}
  End;
End;

Begin
  Error:=0;          {  ! }
  New(ScrArray);
  Assign(F,FileName);
  Reset(F,1);
  BlockRead(F,Fh,SizeOf(TBitmapFileHeader));
  BlockRead(F,Bi,SizeOf(TBitmapInfo));
  If Bi.bmiHeader.biCompression<>bi_RGB Then Error:=1;
  Dy:=Bi.bmiHeader.biHeight;
  DX:=Bi.bmiHeader.biWidth;
  Case Bi.bmiHeader.biBitCount Of
    1:LoadMonoBitmap;
    4:Load16Bitmap;
    8:Load256Bitmap;
    24:Load24Bitmap;
    32:Load32Bitmap;
    Else Error:=2;
  End;
  Close(F);
  Xx:=Bi.bmiHeader.biWidth-1;
  Yy:=Bi.bmiHeader.biHeight-1;
End;

Procedure TBitmap.Draw;
Var I,J:Word;
Begin
  For J:=0 To Yy{-1} Do
    For I:=0 To Xx{-1} Do
      PutPixel(I+Nposx,J+Nposy,ScrArray^[I,J+1]);
End;
Procedure TBitmap.LoadBitmap;
Begin
  Nposx:=X;
  Nposy:=Y;
  Draw;
  End;
Procedure TBitmap.RotateBitmap;
Var
  LocalScr:PScrArray;
  I,J:Word;
Begin
  New(LocalScr);
  LocalScr^:=ScrArray^;
  For J:=Yy Downto 1 Do
    For I:=1 To Xx Do
      ScrArray^[J,I]:=LocalScr^[I,J];
  I:=Xx;
  Xx:=Yy+1;
  Yy:=I-1;
  Dispose(LocalScr);
End;
Procedure TBitmap.VerboseBitmap;
Var
  LocalScr:PScrArray;
  I,J:Word;
Begin
  New(LocalScr);
  LocalScr^:=ScrArray^;
  For I:=1 To Xx-1 Do
    For J:=1 To Yy Do
      ScrArray^[Xx-I,J]:=LocalScr^[I,J];
  Dispose(LocalScr);
End;
Destructor TBitmap.Done;
Begin
  Dispose(ScrArray);
End;
End.